\chapter{Project Implementation}

\section{Overview of Project Module}
The project is structured into several independent modules, each designed to perform specific functions that collectively achieve the project’s objectives.

Key modules include:
\begin{description}
    \item [Data collection and annotation module:]This module gathers resumes and uses an annotation tool to manually label entities such as name, contact information, education and work experience. The annotated dataset serves as the foundation for training the NER model.

    \item [NER model development module:] Using Llama2 framework, this module develops and trains the Named Entity Recognition (NER) model to accurately identify and classify entities with resumes, ensuring precise data extraction

    \item [Database management module:] This module employs the Chroma vector database to store extracted entities as vectors, enabling efficient storage and retrieval of resume data, and supports similarity for matching resumes with job descriptions. 

    \item [Backend Processing module:] This module extracts the required  data from the dataset and gives it to the flask module. 

    \item [Frontend user interface module:] This module gives the user interface and an interactive website. 

    \item [Testing and quality assurance module:] This module ensures system reliability, accuracy and performance through comprehensive unit testing, integration testing, and user acceptance testing (UAT)

    \item [Premium chat feature module:] This advanced module enables HR professionals to interact with resumes via a chat interface powered by Llama2, allowing them to gain deeper insights into candidate profiles and make informed hiring decisions. 
\end{description}

\section{Tools and Technologies used}
\begin{description}
    \item[Label Studio:] A custom annotation platform for manually labelling entities in resume, creating a high quality dataset for training NER model
    \item[Python:] A custom annotation platform for manually labelling entities in resume, creating a high quality dataset for training NER model
    \item[Llama2 Model:] A large language model (LLM) which uses transformers architecture for extracting Named Entities Recognition (NER) task
    \item[Chroma Vector Database:] Chroma is a vector database designed for efficient storage and retrieval of vectorized data. It stores the NER outputs as vectors, enabling quick similarity searches and matching resumes with job descriptions. 
    \item[Git:] A version control system used to manage project’s source code. It allows for efficient collaboration, tracking changes and maintaining source code history.
    \item[Front-end Tools:]  Use of HTML, CSS (Tailwind), Streamlit and JavaScript to make efficient use of space and give a dynamic view to the website.
    \item[Back-end Technologies:]  Use  of Golang  and Flask to connect backend which contains ChromaDB (for storing vector embeddings) and SQLite3 (for user authentication) to the user interface.
\end{description}

\section{Algorithm Details}

\subsection{Algorithm 1: Data collection and annotation}
\begin{itemize}
    \item Input: Collection os Resumes
    \item Output: Annotated dataset for training NER model
    \item Algorithm Steps: 
    \begin{enumerate}
        \item Convert resumes into a consistent text format
        \item Load all the resumes into the annotation tool
        \item Manually identify and label entities (eg., names, contact information, education, work experience, technical skills and soft skills)
        \item Save annotated data in structured format (such as JSON)
    \end{enumerate}
\end{itemize}

\subsection{Algorithm 2: NER model development}
\begin{itemize}
    \item Input: Annotated dataset which is exported in JSON format
    \item Output: Trained NER model
    \item Algorithm steps:
    \begin{enumerate}
        \item Tokenize the text data
        \item Split data into training, validation, and test datasets
        \item Initialise the Llama2 model
        \item Feed the training data into the model
        \item Train the model using supervised learning, optimising for entity recognition
        \item Validate the model using validation set, adjusting the hyperparameters as needed
        \item Test the model using test set
        \item Calculate performance metrics (precision, recall, F1-score)
    \end{enumerate}
\end{itemize}

\subsection{Algorithm 3: Database management}
\begin{itemize}
    \item Input: Extracted entities from resumes
    \item Outputs: Retrieved resumes matching the search criteria
    \item Algorithm steps:
    \begin{enumerate}
        \item Convert the extracted entities into vector representations using a suitable embedding technique
        \item Store vectorized data in the Chroma vector database
        \item Index the vectors for efficient retrieval
        \item Accept search queries (eg., job description)
        \item Convert the queries into vector format
        \item Compute the dot product between query vector and the vectors stored in the database
        \item Retrieve and rank relevant resumes based on vector similarity
    \end{enumerate}
\end{itemize}

\subsection{Algorithm 4: Backend Processing}
\begin{itemize}
    \item Input: API request from frontend (eg., resume submission, search queries)
    \item Output: Processed data sent back to the frontend
    \item Algorithm Steps:
    \begin{enumerate}
        \item Receive the resume data from frontend
        \item Apply the NER model to extract entities
        \item Send extracted entities for manual review and correction
        \item For retrieval, receive search queries from the frontend
        \item Query the chroma vector database
        \item Return retrieved resumes to the frontend 
    \end{enumerate}
\end{itemize}

\subsection{Algorithm 5: Frontend user interface}
\begin{itemize}
    \item Input: User actions (eg., uploading resumes, editing entities, searching for candidates)
    \item Output: Updated and accurate information displayed to the user
    \item Algorithm stpes:
    \begin{enumerate}
        \item Accept resume file from user
        \item Display extracted entities for review and correction
        \item Provide an interface for users to edit extracted entities
        \item Save the corrected entities
        \item Accept search queries
        \item Display retrieved resumes based on query results
    \end{enumerate}
\end{itemize}
